/*
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @author $Author: valikoc $
 * @version $Revision: 69543 $
 */

Legato.I18n = {};

/**
 * Space: li18n
 * URI: Namespace URI
 * http://www.disy.net/legato/i18n
 */
Legato.I18n.NAMESPACE_URI = 'http://www.disy.net/legato/i18n';

/**
 * Prefix: Default prefix
 * li18n
 */
Legato.I18n.PREFIX = 'li18n';

Legato.I18n.LOCALE = null;

Legato.I18n.MESSAGE_SOURCE = null;

Legato.I18n.QName = function(localPart) {
  return new Legato.XML.QName(Legato.I18n.NAMESPACE_URI, localPart,
      Legato.I18n.PREFIX);
};

Legato.I18n.setLocale = function(locale) {
  Legato.Util.Ensure.ensureNotEmptyString(locale);
  Legato.I18n.LOCALE = locale;
  OpenLayers.Lang.setCode(locale);
};

Legato.I18n.getMessage = function(key, context)
{
  if (!Legato.Lang.ObjectUtils.exists(Legato.I18n.MESSAGE_SOURCE))
  {
    Legato.I18n.MESSAGE_SOURCE = new Legato.I18n.MessageSource({'locale' : Legato.I18n.LOCALE, 'messages' : Legato.I18n.Messages});
  }
  return Legato.I18n.MESSAGE_SOURCE.getMessage(key, context);
};