/*
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Legato.Lang.Element = new (Legato.Lang.Class(Legato.Lang.AnySimpleType,
        {
          typeName: 'Legato.Lang.Element',
          isInstance : function(value) {
            return ((typeof value) == 'object'
                && (value.nodeType == 1) && (typeof value.id != 'undefined'));
          },
          fromString : function(value) {
            var element = Legato.Util.getElementById(value);
            if (element) {
              return element;
            } else {
              throw new Error(
                  'Could not find element by id [' + value + '].');
            }
          }
        }))();

/*
Legato.Lang['Element[]'] = Legato.Lang.Element.List();
Legato.Lang['Element{}'] = Legato.Lang.Element.Map();

Legato.Lang.Element.Bean = Legato.Beans.Object.Extend(
  'Legato.Lang.Element',
  //
  Legato.Lang.QName('Element'),
  //
  {
    factoryFunction :Legato.Lang.Element.fromString,
    constructorArguments : {
      id :Legato.Lang.String
    },
    constructorOrder : [ 'id' ]
  }
);
*/